/*
 *  GOL - Game of life simulation software
 *  Copyright (C) 1996 Michael Raymond Brown
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Author: Michael Raymond Brown
 *  EMail:  michael@arrakeen.demon.co.uk
 *  WWW:    http://www.arrakeen.demon.co.uk/
 *  Address:  Michael Brown
 *            Kia Ora
 *            Brook Street
 *            Great Bromley
 *            Nr Colchester
 *            Essex
 *            CO7 7HX
 *            England
 */


#ifdef __GNUC__
#pragma implementation
#endif

#include "Scale.h"
#include <string.h>

xwScale::xwScale(xwWidget* p, const char* title, int min, int max, int o, int x1, int y1, int x2, int y2)
   {
    parent = p;
    widget = XtVaCreateManagedWidget("scale"
		, xmScaleWidgetClass, parent->getWidget()
		, XtVaTypedArg, XmNtitleString, XmRString, title, strlen(title)
		, XmNmaximum, max, XmNminimum, min
		, XmNvalue, min, XmNshowValue, True
		, XmNorientation, o==vertical?XmVERTICAL:XmHORIZONTAL

		, XmNleftAttachment,	XmATTACH_POSITION
		, XmNrightAttachment,	XmATTACH_POSITION
		, XmNtopAttachment,	XmATTACH_POSITION
		, XmNbottomAttachment,	XmATTACH_POSITION

		, XmNleftPosition,	x1
		, XmNrightPosition,	x2
		, XmNtopPosition,	y1
		, XmNbottomPosition,	y2

		, 0);

    default_callbacks(evnt_Change, meth_Value|meth_Size|meth_Close);
    linkParent(p);

    XtAddCallback(widget, XmNdragCallback, cbDrag, (XtPointer)this);
   }
xwScale::xwScale(xwWidget* p, const char* title, int min, int max, int o)
   {
    parent = p;
    widget = XtVaCreateManagedWidget("scale"
		, xmScaleWidgetClass, parent->getWidget()
		, XtVaTypedArg, XmNtitleString, XmRString, title, strlen(title)
		, XmNmaximum, max, XmNminimum, min
		, XmNvalue, min, XmNshowValue, True
		, XmNorientation, o==vertical?XmVERTICAL:XmHORIZONTAL
		, 0);

    default_callbacks(evnt_Change, meth_Value|meth_Size|meth_Close);
    linkParent(p);

    XtAddCallback(widget, XmNdragCallback, cbDrag, (XtPointer)this);
   }
xwScale::~xwScale()
   {
   }

void xwScale::cbDrag(Widget w, XtPointer client_data, XtPointer call_data)
   {xwScale* me = (xwScale*)client_data;
    if (me->handler) me->handler->onChange(me, me->handler_arg);
   }



